/* USER CODE BEGIN Header */
/**
 ******************************************************************************
 * @file           : main.h
 * @brief          : Header for main.c file.
 *                   This file contains the common defines of the application.
 ******************************************************************************
 * @attention
 *
 * <h2><center>&copy; Copyright (c) 2022 STMicroelectronics.
 * All rights reserved.</center></h2>
 *
 * This software component is licensed by ST under BSD 3-Clause license,
 * the "License"; You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at:
 *                        opensource.org/licenses/BSD-3-Clause
 *
 ******************************************************************************
 */
/* USER CODE END Header */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "stm32g4xx_hal.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Exported types ------------------------------------------------------------*/
/* USER CODE BEGIN ET */

/* USER CODE END ET */

/* Exported constants --------------------------------------------------------*/
/* USER CODE BEGIN EC */
#define THRESH_UV 32768 /* 2.5V */
#define THRESH_OV 55050 /* 4.2V */
#define THRESH_UT 0     /* 0C */
#define THRESH_OT 880   /* 55C */

#define AMS_ERRORCODE_TIMEOUT_SLAVE 1
#define AMS_ERRORCODE_SLAVE_PANIC 2
#define AMS_ERRORCODE_TIMEOUT_SHUNT 6
#define AMS_ERRORCODE_MASTER_THRESH 7

#define AMS_ERRORFLAG_MASTER_THRESH_UT 0
#define AMS_ERRORFLAG_MASTER_THRESH_OT 1
#define AMS_ERRORFLAG_MASTER_THRESH_UV 2
#define AMS_ERRORFLAG_MASTER_THRESH_OV 3
/* USER CODE END EC */

/* Exported macro ------------------------------------------------------------*/
/* USER CODE BEGIN EM */

/* USER CODE END EM */

void HAL_TIM_MspPostInit(TIM_HandleTypeDef* htim);

/* Exported functions prototypes ---------------------------------------------*/
void Error_Handler(void);

/* USER CODE BEGIN EFP */
void AMS_Error_Handler(uint8_t ErrorCode, uint32_t nErrorArgs,
                       uint8_t* ErrorArgs);
/* USER CODE END EFP */

/* Private defines -----------------------------------------------------------*/
#define AMS_ERROR_Pin GPIO_PIN_0
#define AMS_ERROR_GPIO_Port GPIOA
#define SD_Select_Pin GPIO_PIN_2
#define SD_Select_GPIO_Port GPIOB
#define Status_LED_Pin GPIO_PIN_10
#define Status_LED_GPIO_Port GPIOB
#define Soft_TSAL_Pin GPIO_PIN_11
#define Soft_TSAL_GPIO_Port GPIOB
#define InterSTM_SPI_CS_Pin GPIO_PIN_8
#define InterSTM_SPI_CS_GPIO_Port GPIOA
#define InterSTM_IRQ_Line_Pin GPIO_PIN_9
#define InterSTM_IRQ_Line_GPIO_Port GPIOA
/* USER CODE BEGIN Private defines */

/* USER CODE END Private defines */

#ifdef __cplusplus
}
#endif

#endif /* __MAIN_H */
